TokenUser			     = 1
TokenGroups			     = 2
TokenPrivileges 		     = 3
TokenOwner			     = 4
TokenPrimaryGroup		     = 5
TokenDefaultDacl		     = 6
TokenSource			     = 7
TokenType			     = 8
TokenImpersonationLevel 	     = 9
TokenStatistics 		     = 10
TOKEN_ADJUST_PRIVILEGES 	     = 20h

TOKEN_ASSIGN_PRIMARY = (0001h)
TOKEN_DUPLICATE = (0002h)
TOKEN_IMPERSONATE = (0004h)
TOKEN_QUERY = (0008h)
TOKEN_QUERY_SOURCE = (0010h)
TOKEN_ADJUST_GROUPS = (0040h)
TOKEN_ADJUST_DEFAULT = (0080h)
TOKEN_ADJUST_SESSIONID = (0100h)
TOKEN_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED+TOKEN_ASSIGN_PRIMARY+TOKEN_DUPLICATE+ \
			  TOKEN_IMPERSONATE+TOKEN_QUERY+TOKEN_QUERY_SOURCE+ \
			  TOKEN_ADJUST_PRIVILEGES+TOKEN_ADJUST_GROUPS+TOKEN_ADJUST_SESSIONID+ \
			  TOKEN_ADJUST_DEFAULT)
TOKEN_READ = (STANDARD_RIGHTS_READ+TOKEN_QUERY)
TOKEN_WRITE = (STANDARD_RIGHTS_WRITE+TOKEN_ADJUST_PRIVILEGES+TOKEN_ADJUST_GROUPS+TOKEN_ADJUST_DEFAULT)
TOKEN_EXECUTE = (STANDARD_RIGHTS_EXECUTE)
TOKEN_SOURCE_LENGTH = 8

TokenPrimary		= 1
TokenImpersonation	= 2

TokenRestrictedSids	= 11
TokenSessionId		= 12

ANYSIZE_ARRAY		= 1

struc GUID {
    .Data1	 dd ?
    .Data2	 dw ?
    .Data3	 dw ?
    .Data4	 rb 8
}
struct GUID

struc LUID {
  .LowPart   dd 	?
  .HighPart  dd 	?
}
struct LUID

struc SID_AND_ATTRIBUTES {
  .Sid		 dd	 ?
  .Attributes	 dd	 ?
}
struct SID_AND_ATTRIBUTES

struc SID_IDENTIFIER_AUTHORITY {
  .Value  rb 6
}
struct SID_IDENTIFIER_AUTHORITY

struc LUID_AND_ATTRIBUTES {
    .Luid LUID
    .Attributes dd ?
}
struct LUID_AND_ATTRIBUTES

struc SID {
   .Revision db ?
   .SubAuthorityCount db ?
   .IdentifierAuthority SID_IDENTIFIER_AUTHORITY
   .SubAuthority	dd ?
}
struct SID

struc ACE_HEADER {
    .AceType db ?
    .AceFlags db ?
    .AceSize dw ?
}
struct ACE_HEADER

struc ACCESS_ALLOWED_OBJECT_ACE {
    .Header ACE_HEADER
    .Mask1 dd		 ?
    .Flags dd		 ?
    .ObjectType GUID
    .InheritedObjectType GUID
    .SidStart dd	 ?
}
struct ACCESS_ALLOWED_OBJECT_ACE

struc ACCESS_DENIED_OBJECT_ACE {
    .Header ACE_HEADER
    .Mask1 dd		 ?
    .Flags dd		 ?
    .ObjectType GUID
    .InheritedObjectType GUID
    .SidStart dd	 ?
}
struct ACCESS_DENIED_OBJECT_ACE

struc SYSTEM_AUDIT_OBJECT_ACE {
    .Header ACE_HEADER
    .Mask1 dd		 ?
    .Flags dd		 ?
    .ObjectType GUID
    .InheritedObjectType GUID
    .SidStart dd	 ?
}
struct SYSTEM_AUDIT_OBJECT_ACE

struc SYSTEM_ALARM_OBJECT_ACE {
    .Header ACE_HEADER
    .Mask1 dd	     ?
    .Flags dd	     ?
    .ObjectType GUID
    .InheritedObjectType GUID
    .SidStart dd     ?
}
struct SYSTEM_ALARM_OBJECT_ACE

struc SECURITY_DESCRIPTOR_RELATIVE {
    .Revision db     ?
    .Sbz1 db	     ?
    .Control1 dw     ?
    .Owner dd	     ?
    .Group1 dd	     ?
    .Sacl dd	     ?
    .Dacl dd	     ?
}
struct SECURITY_DESCRIPTOR_RELATIVE

struc OBJECT_TYPE_LIST {
    .Level dw	     ?
    .Sbz dw	     ?
    .ObjectType dd   ?
}
struct OBJECT_TYPE_LIST

struc TOKEN_USER {
    .User SID_AND_ATTRIBUTES
}
struct TOKEN_USER

struc TOKEN_OWNER {
    .Owner dd ?
}
struct TOKEN_OWNER

struc TOKEN_PRIMARY_GROUP {
    .PrimaryGroup dd ?
}
struct TOKEN_PRIMARY_GROUP

struc TOKEN_DEFAULT_DACL {
    .DefaultDacl dd ?
}
struct TOKEN_DEFAULT_DACL

struc TOKEN_SOURCE {
    .SourceName rb TOKEN_SOURCE_LENGTH
    .SourceIdentifier LUID
}
struct TOKEN_SOURCE

struc TOKEN_CONTROL {
    .TokenId LUID
    .AuthenticationId LUID
    .ModifiedId LUID
    .TokenSource1 TOKEN_SOURCE
}
struct TOKEN_CONTROL

struc TOKEN_GROUPS {
  .GroupCount	 dd	 ?
  .Groups	 SID_AND_ATTRIBUTES
}
struct TOKEN_GROUPS

struc TOKEN_PRIVILEGES {
  .PrivilegeCount    dd      ?
  .Privileges	     LUID_AND_ATTRIBUTES
}
struct TOKEN_PRIVILEGES
